
/* gcc -oO3 -ggdb -Wall ib.c -o ib  */

#include "main.h"
/* checker does not work with epoll. try valgrind or memprof */

/* Not using UDP as I would have to change the firewall to accommodate UDP */
/* events based mechanism is the way to go. Read about the comparisions between event based mechanisms such as epoll and threaded implementations. epoll is a lot better than select that I used to use before
tcpechoServer.c: echoes everything from the client back to the client
gcc tcpechoServer.c -o server
tcpechoClient.c: reads the input from stdin and sends it to the server and reads the server output
gcc tcpechoClient.c -o client
tcpclient.c: tcpechoClient.c modified with epoll
gcc tcpclient.c common.c ibp.c ibl.c stgp.c stgl.c -o client
after the server has been started, check out with netstat -anp | grep -i <port>, to see if the server is binding to the port. port = 6003 above
picked up the echo server and client idea to test from Chapter 6 of UNIX network programming book by Richard Stevens
*/
int get_sock ( int sockfd, int port,int * epollfdptr, struct epoll_event *eventptr)
  {
  struct sockaddr_in	their_addr;

/* TODO */
    send_close_window_message(); 
    /* cannot have exit() for the failure as that would kill all the processing even if one has an error
     * use return instead */

    /* shutdown and close the socket if it is a non-null or non-zero value */
    if (sockfd) { 
       shutdown (sockfd, SHUT_RDWR); close (sockfd);
    }
    /* set up socket  */
    if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) { 
       perror("socket failure"); DP(1,("socket failure")); DE(10,"get_sock"); return 0; /* exit(1); */
    }

	   /* set up server address  */
    their_addr.sin_family = AF_INET;	/* host byte order */
    their_addr.sin_port = htons(port);  /* short, network byte order */
    their_addr.sin_addr.s_addr = inet_addr("127.0.0.1");
    memset(&(their_addr.sin_zero), '\0', 8);  /* zero the rest of the struct */

    /* connect to server  */
    /* I did not see any difference because of this option. But, I think that it might have an effect */
    /* int y = 1; setsockopt(sockfd,IPPROTO_TCP, TCP_NODELAY, (char *) &y, y); */
    
    /* connect failure to which address and port. Also get rid of the exit() on failure. use return instead */
    if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) < 0) {
      /* added sleep here to give a chance to close the window */
      /* get the sleep here to as less as possible */
       sleep(10);
       perror("connect failed"); DP(1,("connect failure to port:%i",port)); DE(10,"main"); 
       return 0;
        /* exit(EXIT_FAILURE); */
    }

/*  if (connect(sockfd, (struct sockaddr *) &serv, sizeof(serv)) < 0) {
     perror( "connect failed");
     DP(1, ("%s", "Could not connect to close_windows socket at 127.0.0.1:6003"));
     return;
  }
  */

  (*eventptr).events = EPOLLIN | EPOLLOUT | EPOLLERR | EPOLLHUP;
  (*eventptr).data.fd = sockfd;
  DP(1,( "sockfd: %i\n",sockfd ));
  if (0 > epoll_ctl ( (*epollfdptr), EPOLL_CTL_ADD, sockfd, eventptr)) {
    perror( "epoll_ctl");
    printf("epoll error\n");
  }
  return sockfd;
}

void read_data_from_socket(struct data * dataptr,struct epoll_event * recvd_events_ptr) {
  DP(10,("start location:%i for buffer read received on:%s",dataptr->startloc,dataptr->account));
  if ( 0 > (dataptr->bytes_recvd += read(dataptr->sockfd, &dataptr->rbuf[dataptr->startloc], READBUFSIZE - 3 - dataptr->startloc )) ){
     if ( ECONNRESET == errno ) { /* will this work? copied from pg 174 of Richard Stevens */
        close_connection(dataptr,recvd_events_ptr);
     }
  }
  else {
     dataptr->bytes_recvd += dataptr->startloc;
     dataptr->startloc = 0;
     dataptr->time_data_recvd = time(NULL);
     DP(10,("%i bytes received on %s",dataptr->bytes_recvd, dataptr->account));
  }
}

void close_connection(struct data * dataptr,struct epoll_event * recvd_events_ptr) {
  if (dataptr && dataptr->sockfd) {
    shutdown(dataptr->sockfd, SHUT_RDWR); 
    close(dataptr->sockfd);
    dataptr->sockfd = 0;
  }
  if (recvd_events_ptr && recvd_events_ptr->data.fd) {
    shutdown(recvd_events_ptr->data.fd, SHUT_RDWR); 
    close(recvd_events_ptr->data.fd);
    recvd_events_ptr->data.fd = -1;
  }
  dataptr->close_connection = 0;
}

int request_market_data ( struct data * dataptr ) {
  int i = 0;
  char expiry[7];
  for ( i=0; i < dataptr->ssize - dataptr->sempty; i++) {
    if ( FALSE == dataptr->stks[i].requested_market_data ) {
       write_integers(dataptr->sockfd, dataptr->wbuf,3,REQ_MKT_DATA, 5, i);
       memset(expiry, '\0',7);
       if (dataptr->stks[i].expiry) strncpy(expiry, dataptr->stks[i].expiry,6);
       /* write_strings(dataptr->sockfd,dataptr->wbuf,3,dataptr->stks[i].symbol, dataptr->stks[i].sectype, dataptr->stks[i].expiry); */
       write_strings(dataptr->sockfd,dataptr->wbuf,3,dataptr->stks[i].symbol, dataptr->stks[i].sectype, expiry);
       write_floats(dataptr->sockfd, dataptr->wbuf,1,dataptr->stks[i].strike);
       write_strings(dataptr->sockfd, dataptr->wbuf,7,dataptr->stks[i].right,"0", dataptr->stks[i].exchange,dataptr->stks[i].exchange,dataptr->stks[i].currency, dataptr->stks[i].localsymbol,"0");

       /* write_integers(sockfd, buf,1,0); */
       /* write_strings(sockfd, buf,11,"1","3","0","IBM", "STK","200501","1.00","C","SMART","USD","IBM"); */
       /* printf("%s\n",buf); */
       /* if ((numbytes = write(sockfd,buf, strlen(buf))) < strlen(buf) ) {DPRINT(1,("Could not write to the socket: %s, bytes to send: %i\n", buf, strlen(buf) ));} */

       dataptr->stks[i].requested_market_data = TRUE;
    } /* if ( FALSE == dataptr.stks[i].requested_market_data ) */
  } /* for ( i=0; i < dataptr.ssize - dataptr.sempty; i++)  */
  return 1;
}

int request_contract_details( struct data * dataptr ) {
  int i = 0;
  for ( i=0; i < dataptr->ssize - dataptr->sempty; i++) {
       write_integers(dataptr->sockfd, dataptr->wbuf,2,REQ_CONTRACT_DATA, 2);
       write_strings(dataptr->sockfd,dataptr->wbuf,3,dataptr->stks[i].symbol, dataptr->stks[i].sectype, dataptr->stks[i].expiry);
       write_floats(dataptr->sockfd, dataptr->wbuf,1,dataptr->stks[i].strike);
       write_strings(dataptr->sockfd, dataptr->wbuf,5,dataptr->stks[i].right,"0", dataptr->stks[i].exchange, dataptr->stks[i].currency, dataptr->stks[i].localsymbol);

       /* write_integers(sockfd, buf,1,0); */
       /* write_strings(sockfd, buf,11,"1","3","0","IBM", "STK","200501","1.00","C","SMART","USD","IBM"); */
       /* printf("%s\n",buf); */
       /* if ((numbytes = write(sockfd,buf, strlen(buf))) < strlen(buf) ) {DPRINT(1,("Could not write to the socket: %s, bytes to send: %i\n", buf, strlen(buf) ));} */

  } /* for ( i=0; i < dataptr.ssize - dataptr.sempty; i++)  */
  return 1;
}

int connect_to_ib (struct data * dataptr, int * epollfdptr, struct epoll_event * event_to_registerptr, struct epoll_event * recvd_events_ptr) {
  struct tokenvalue tok;
  /* using sockfd as a local variable to keep my dereferences down */
  int numbytes = 0, number_of_retries = 0;
  dataptr->clientid++;
  if ( 0 < (dataptr->sockfd = get_sock ( dataptr->sockfd, dataptr->port, epollfdptr, event_to_registerptr ) ) ) {

     /* resetting the parser */
     if ( dataptr->parser) {
       ibparse (dataptr->parser, 0, tok, dataptr);
     }
     /* resetting the scanner buf */
     memset(dataptr->wbuf, '\0',WRITEBUFSIZE); 
     memset(dataptr->rbuf, '\0',READBUFSIZE); 


     /* set client version what's the 1 here? message version */ 
     write_integers(dataptr->sockfd, dataptr->wbuf, 1, CLIENT_VERSION);
     /* while ( (numbytes=read(dataptr->sockfd, dataptr->rbuf, READBUFSIZE-1)) <= 0)  */
     while ( number_of_retries < 2 && (numbytes=read(dataptr->sockfd, dataptr->rbuf, READBUFSIZE-1)) <= 0) {
        DP(1,("%s: Could not retreive the server version. Sleeping for 10 secs..", dataptr->account)); 
        sleep(10); 
        dataptr->close_connection = 1;
        number_of_retries++;
     }
     if ( 2 == number_of_retries ) return 0;
     else if ( 0 < numbytes) dataptr->close_connection = 0;

     dataptr->rbuf[numbytes] = '\0';
     DP(1,("Received Server version: %s in %i bytes",dataptr->rbuf,numbytes));
     if (atoi(dataptr->rbuf) < SERVER_VERSION) { DP(1,("Upgrade the TWS client. It is way behind the supported server version")); exit(1); }
     memset(dataptr->rbuf,'\0',numbytes + 1);

  /* set client id */
     write_integers(dataptr->sockfd, dataptr->wbuf, 1, dataptr->clientid);

  /* set server log level where 1 is the version retreived from the JAVA client API source */
     write_integers(dataptr->sockfd, dataptr->wbuf, 3, SET_SERVER_LOG_LEVEL,1,SERVER_LOG_LEVEL); /*write_strings(sockfd, buf, 3,"14","1","2"); */


  /*Client.reqAccountUpdates(TRUE,account); where 2 is the version of this write, retreived from the Java client API source */
     write_integers(dataptr->sockfd, dataptr->wbuf, 3, REQ_ACCOUNT_DATA, 2, TRUE);
     write_strings(dataptr->sockfd, dataptr->wbuf, 1, dataptr->account); /*write_strings(sockfd, buf, 1, "U181852" ); */

  /*Client.reqopenorders */
     write_integers(dataptr->sockfd, dataptr->wbuf, 2, REQ_OPEN_ORDERS, 1);

  /*Client.reqAllOpenOrders */
    write_integers(dataptr->sockfd, dataptr->wbuf, 2, REQ_ALL_OPEN_ORDERS, 1);
  } /* if ( 0 < (dataptr->sockfd = get_sock ( dataptr->sockfd, dataptr->port, epollfdptr, event_to_registerptr ) ) ) */
  return 1;
}

void parse_data ( struct data * dataptr) {
  struct Scanner * scannerptr = &dataptr->scanner;

  /* cannot have a memory location as the value there changes when the next token is reached */
  /* when the parser tries to read the value from that location, it gets the next token */
  /* char* tokvalue = (char *) calloc (100, sizeof(char)); */
  struct tokenvalue tok;
/*  char tokvalue[10]; */
  int token = 0;
  /* int error_code;
  char err_msg[80];
  int counter = 0; */

  DB(10, ("parse_data"));

  memset(tok.value, '\0', TOKVALUESIZE);

/* Socket read max size: BUFSIZE - 3 - startloc
 *   capture bytes recvd 
 *   add the startloc to the bytes recvd to arrive at the total bytes recvd in the buffer
 *   scannerptr->lim = scannerptr->eof = buf[bytes_recvd + 2]
 *   scannerptr->top set during initialisation to buf[BUFSIZE -1]
 *   
 *     I am doing the above to avoid fill() being called. It is called when scannerptr->lim - scannerptr->cur < 2
 *     In the above case, by adding 2 null characters at the end of the buffer, I am avoiding 
 *     the fill from being called
 *     
 *     while loop:
 *       if there is a '\0' between ptr and n = num of bytes recvd
 *         if NOT( scannerptr->lim - strchr(ptr,'\0') < 2 ) then
 *           keep going
 *         else
 *           refill or restack the buffer
 *           reset pointers (all to begin as in fill except scannerptr->lim, scannerptr->eof, scannerptr->top)
 *           if ptr == buf[0] i.e if the ptr is at the beginning of the buffer and still no NULL
 *           characters are found, then the size of the string received is > BUFSIZE
 *              exit(EXIT_FAILURE) and also an error message that the string size received > BUFSIZE
 *
 *     memset initialisation before each read: memset(buf[strlen(buf)],'\0',prev_bytes_recvd
 *     startlocation for the next socket read = buf[strlen(buf)]
 */

  /* http://webster.cs.uga.edu/~cashin/re2c/scanner.c */
  scannerptr->lim = scannerptr->eof = (uchar *) &dataptr->rbuf[dataptr->bytes_recvd + 2];
  /* scannerptr->top set during initialisation to buf[READBUFSIZE BUFSIZE -1] */
  scannerptr->pos = scannerptr->cur = scannerptr->ptr = scannerptr->tok = scannerptr->bot = (uchar *) dataptr->rbuf;
  scannerptr->top = (uchar *) &dataptr->rbuf[READBUFSIZE -1];
  scannerptr->fd = 0; /* close(scanner.fd);  */

  /* while loop: if there is a '\0' between ptr and n = num of bytes recvd */
  /* if NOT( scannerptr->lim - strchr(ptr,'\0') < 2 ) then */
  /* if ( (READBUFSIZE - 2 == dataptr->bytes_recvd) && (2 > (scannerptr->lim - strchr(dataptr->buf, '\0'))) )  */
  if ( (READBUFSIZE - 3 == dataptr->bytes_recvd) && (strlen(dataptr->rbuf) == dataptr->bytes_recvd) ) {
    DP(1,("string size received > READBUFSIZE\n"));
    DP(1,("string: %s\n", dataptr->rbuf));
    exit(EXIT_FAILURE);
  }
  /* TODO +1 needed here */
  /* while ( 2 < strlen( (char *) &scannerptr->cur) )  */
  /* BELOW CODE WILL NOT WORK as this is a chicken and egg scenario. The cptrn will not be set to zero until the message is reduced and the message is not reduced until the next token is received.
   * Revert TO THE PATTERN BASED LOGIC */
  /* avoided the above case by making s->cur = s->tok in the syntax error routine */
  /* using the strleng to avoid picking only the token value and not its trailing null */
  /* while ( scannerptr->lim - scannerptr->cur > 2 && scannerptr->lim - scannerptr->cur - strlen( (char *) scannerptr->cur ) > 2 )  */
  while ( scannerptr->lim - scannerptr->cur > 2 && 
	  scannerptr->lim - scannerptr->cur - strlen( (char *) scannerptr->cur ) > 2 &&
/* 	  adding lookahead of one token when the cptrn = 0 */
	  ( dataptr->cptrn ||
	    (0 == dataptr->cptrn && 
	          scannerptr->lim - scannerptr->cur - strlen( (char *) scannerptr->cur ) - 1 -
	            strlen( (char *) scannerptr->cur + strlen( (char *) scannerptr->cur ) + 1 ) > 2 )
	  )
	) {
  /* keep going */
    if (dataptr->cptrn) token = ibl_value_scan(scannerptr);
    /* else if (dataptr->cptrn){ */
      /* token = ibl_version_scan(scannerptr); */
      /* dataptr->cver = token; */
    /* } */
    else {
      /* moving the control of the null token from re2c to the below line as the while clause will catch the scenario when cur nears lim - 2 */
      if (!(token = ibl_token_scan(scannerptr))) continue; 
      dataptr->cptrn = token;
      /* dataptr->cver = 0; */
    }

    /* tok.size = increase( (void *) &tok.value, tok.size, sizeof(char) ) ; */ 
    if (TOKVALUESIZE < scannerptr->cur - scannerptr->tok ) {
       DP(1,("token %d value (%.*s) greater than 100 chars\n", token, scannerptr->cur - scannerptr->tok, scannerptr->tok));
       exit(EXIT_FAILURE);
    }
    memcpy(tok.value, (char *)scannerptr->tok, scannerptr->cur - scannerptr->tok );
    tok.value[ scannerptr->cur - scannerptr->tok ] = '\0';
    DP(10,("%i\t%.*s\n", token, scannerptr->cur - scannerptr->tok, scannerptr->tok));
    DP(10,("%i\n", token)); 
    ibparse(dataptr->parser, token, tok,dataptr);
    if ( ibparse_next_action_is_a_shift(dataptr->parser) ){
      /* below free not actually necessary */
      ibparse(dataptr->parser, 0, tok,dataptr);
      dataptr->cptrn = 0;
      /* dataptr->cver = 0; */
    }
  } /* while ( scannerptr->lim - scannerptr->cur > 2 ) */

  /* memmove any memory left in the buf to the beginning */
  /* reset pointers (all to begin as in fill except scannerptr->lim, scannerptr->eof, scannerptr->top) */
  /* move any existing token to the beginning of the buffer */
  /* http://webster.cs.uga.edu/~cashin/re2c/scanner.c */

  /* cannot get the resetting to work */

  /* not using the below comparision as I might get lesser data because of the writer's lack of autoflush  */
  /* if ( READBUFSIZE - 3 == dataptr->bytes_recvd )   */
  /* Is the below a good idea. Assumption: if the last byte received is a null, then assume that the message has been received fully */
  /* if ( '\0' == dataptr->rbuf[dataptr->bytes_recvd-1] )   */
    /* resetting the parser so that any rule that has not been reduced will be reduced instead of waiting for the next tokvalue */
    /* DP(1,("Sending parser free bytes received: %i\n", dataptr->bytes_recvd));  */
    /* ibparse( dataptr->parser, 0, tok, dataptr );  */
     dataptr->startloc = scannerptr->lim - scannerptr->cur - 2 ;
     memmove(dataptr->rbuf, scannerptr->cur, scannerptr->lim - scannerptr->cur );
/*      dataptr->rbuf[scannerptr->lim - scannerptr->cur - 1] = '\0'; */
/*      do i need the below? the memset underneath is taking care of it */
     dataptr->rbuf[ dataptr->startloc ] = '\0';
     /* memset initialisation before each read: memset(buf[strlen(buf)],'\0',prev_bytes_recvd */
     memset( &dataptr->rbuf[dataptr->startloc],'\0', dataptr->bytes_recvd - dataptr->startloc);
     dataptr->bytes_recvd = 0;
  
  DE(10, ("parse_data"));
}




int check( double operand1, char * operator, double operand2 ) {
  if ( '\0' == operator[1] ) {
    if ( '<' == operator[0] )
      return ( operand1 < operand2 );
    else if ( '>' == operator[0] )
      return ( operand1 > operand2 );
  }
  else if ( '=' == operator[1] ) {
    if ( '<' == operator[0] )
      return ( operand1 <= operand2 );
    else if ( '>' == operator[0] )
      return ( operand1 >= operand2 );
    else if ( '=' == operator[0] )
      return ( operand1 == operand2 );
    else if ( '!' == operator[0] )
      return ( operand1 != operand2 );
  }
  else if ( '>' == operator[1] && '<' == operator[0] ) {
      return !( operand1 == operand2 );
  }
  else {DP(1,(" %s is not a valid comparing operator ", operator ));}
  return FALSE;
}

int price_check ( struct trade * trade, double last, double bid, double ask) {
  double price = 0;
  if ('b' == trade->price_type[0] || 'B' == trade->price_type[0] ) price = bid;
  else if ('a' == trade->price_type[0] || 'A' == trade->price_type[0] ) price = ask;
  else if ('l' == trade->price_type[0] || 'L' == trade->price_type[0] ) price = last;

  /* do not go further if the price == 0, Assuming that there will never be a zero price */
  if (!price) return 0;

/*  if trade_price then */
  if ( trade->trade_price ) {
/*    if ( TRUE == check(price, operator, trade_price) ) */
    if ( TRUE == check(price, trade->trade_operator, trade->trade_price) ) {
/*      change trade_status = PLACEORDER and return; */
      trade->status = PLACEORDER;
      return 1; 
    }
   /* for longs, trail is -ve and trail op > */
   /* for shorts, trail is +ve and trail op < */
   /* else if ( TRUE == check(price + trail, trailing_operator, trade_price) ) */
    else if (trade->trailing_operator && trade->trailing_margin && TRUE == check(price + trade->trailing_margin, trade->trailing_operator, trade->trade_price)){  
   /*   trade_price = price + trail; */
      trade->trade_price = price + trade->trailing_margin;
      trade->status = TRAILING;
  } /* if ( trade->open ) */
  /* else if (trigger_operator and trigger_price) then */
  else if (trade->trigger_operator && trade->trigger_price) 
    /* if ( TRUE == check( price, trigger_operator, trigger_price) ) */
    if ( TRUE == check( price, trade->trigger_operator, trade->trigger_price) ) {
      /* trade_price = price + trail */
      trade->trade_price = price + trade->trailing_margin;
      trade->status = TRIGGERED;
    } /* if ( TRUE == check( price, trade->trigger_operator, trade->trigger_price) ) */
  }
return 0;
}

/* compare price and change trade status to PLACEORDER */
/* if any child trade has a status of CLOSED, then change the current_trade_state to that one */
int strategy_state_change ( struct data * dataptr ) {
  int stkidx = 0, return_value = 0, trdidx = 0, childtrdid = 0;
  for ( stkidx = 0; stkidx < dataptr->ssize - dataptr->sempty; stkidx++ ) {
    /* if trade_status < PLACEORDER then price_check */
    if ( 0 > dataptr->stks[stkidx].current_trade_state ) continue;
    else if ( (PLACEORDER > dataptr->trds[dataptr->stks[stkidx].current_trade_state].status) && 
	(TRUE == price_check( &dataptr->trds[dataptr->stks[stkidx].current_trade_state], dataptr->stks[stkidx].last, dataptr->stks[stkidx].bid, dataptr->stks[stkidx].ask )) 
	) {
      dataptr->trds[dataptr->stks[stkidx].current_trade_state].status = PLACEORDER ;
      return_value = 1;
    }
    /* else if trade_status = CLOSED then */
    else if ( CLOSED == dataptr->trds[dataptr->stks[stkidx].current_trade_state].status ) {
    /* for each child */
      for ( trdidx = 0; trdidx < dataptr->trds[dataptr->stks[stkidx].current_trade_state].no_of_children; trdidx++ ) {
        childtrdid = dataptr->trds[dataptr->stks[stkidx].current_trade_state].children[trdidx] ;
    /*  if ( CLOSED == STATUS ) move the stock to that current trade state */
        if ( CLOSED == dataptr->trds[childtrdid].status ) {
          dataptr->stks[stkidx].current_trade_state = childtrdid ;
          return_value = 1;
        }
      } /* for ( trdidx = 0; trdidx < dataptr->trds[dataptr->stks[stkidx].current_trade_state].no_of_children; trdidx++ ) */
      for ( trdidx = 0; trdidx < dataptr->trds[dataptr->stks[stkidx].current_trade_state].no_of_children; trdidx++ ) {
        childtrdid = dataptr->trds[dataptr->stks[stkidx].current_trade_state].children[trdidx] ;
    /*  if ( TRUE == price_check ) then update the status of that child trade */
        if ( PLACEORDER > dataptr->trds[childtrdid].status && TRUE == price_check( &dataptr->trds[childtrdid], dataptr->stks[stkidx].last, dataptr->stks[stkidx].bid, dataptr->stks[stkidx].ask )) {
          dataptr->trds[childtrdid].status = PLACEORDER ;
          return_value = 1;
        } /* if ( PLACEORDER > dataptr->trds[childtrdid].status && TRUE = price_check( dataptr->trds[dataptr->stks[stkidx], dataptr->stks[stkidx].price ) */
      } /* for ( trdidx = 0; trdidx < dataptr->trds[dataptr->stks[stkidx].current_trade_state].no_of_children; trdidx++ ) */
    } /* else if ( CLOSED == dataptr->trds[dataptr->stks[stkidx].current_trade_state].status ) */
  } /* for ( stkidx = 0; stkidx < dataptr->ssize - dataptr->sempty; stkidx++ ) */
  return return_value;
} /* int strategy_state_change ( struct data * dataptr ) */

void send_order ( struct data * dataptr, int stkidx, int trdidx ) {
  char expiry[7];
  struct stock *stk = &dataptr->stks[stkidx];
  /*write_integers(sockfd, buf, 3, PLACEORDER, 7, 2);*/
  /*NEW changed 7 to 13 below*/
  write_integers(dataptr->sockfd, dataptr->wbuf, 3, PLACE_ORDER, 16, dataptr->orderid);
  dataptr->trds[trdidx].orderid = dataptr->orderid;
  dataptr->orderid++;
  /*write_strings(sockfd, buf, 3,"RIMM", "OPT","200404");*/
  /* write_strings(dataptr->sockfd, dataptr->wbuf, 3,"IBMDP",stk->sectype,"200504");  */
  /* wish I could do a substring here instead of using a local variable */
  memset(expiry, '\0',7);
  if (stk->expiry) strncpy(expiry, stk->expiry,6);
  write_strings(dataptr->sockfd, dataptr->wbuf, 3,stk->symbol,stk->sectype,expiry);
  /* write_strings(dataptr->sockfd, dataptr->wbuf, 3,stk->symbol,stk->sectype,stk->expiry); */
  /*write_floats(sockfd, buf, 1, 0);*/
  write_floats(dataptr->sockfd, dataptr->wbuf, 1, stk->strike);
  if ( 0 < dataptr->trds[trdidx].quantity ) {
    /*write_strings(sockfd, buf, 5,"0","SMART","USD","RUPDR","BUY");*/
    /* multiplier */
    /* multiplier of 0 works with options */
    /* write_integers(dataptr->sockfd, dataptr->wbuf, 1, 0); */
    write_strings(dataptr->sockfd, dataptr->wbuf, 7,stk->right, stk->multiplier,stk->exchange,stk->exchange,stk->currency,stk->localsymbol,"BUY" );
    /*write_integers(sockfd, buf, 1, 0);*/
    write_integers(dataptr->sockfd, dataptr->wbuf, 1, dataptr->trds[trdidx].quantity );
  }
  else if ( 0 > dataptr->trds[trdidx].quantity ) {
    /*write_strings(sockfd, buf, 5,"0","SMART","USD","RUPDR","BUY");*/
    /* write_strings(dataptr->sockfd, dataptr->buf, 5,stk->right,stk->exchange,stk->currency,stk->localsymbol, "SELL" ); */
    /* multiplier */
    write_strings(dataptr->sockfd, dataptr->wbuf, 7,stk->right, stk->multiplier,stk->exchange,stk->exchange,stk->currency,stk->localsymbol,"SELL" );
    /*write_integers(sockfd, buf, 1, 0);*/
    write_integers(dataptr->sockfd, dataptr->wbuf, 1, -1 * dataptr->trds[trdidx].quantity );
  }
  /*write_strings(sockfd, buf, 1,"LMT");*/
  write_strings(dataptr->sockfd, dataptr->wbuf, 1,"LMT" );
  /*write_floats(sockfd, buf, 2, 0, 0);*/
  write_floats(dataptr->sockfd, dataptr->wbuf, 2, dataptr->trds[trdidx].trade_price, dataptr->trds[trdidx].trade_price);
  /*write_strings(sockfd, buf, 6,"GTC","0","0","C","0","0");*/
  /*tif, ocagroup, account, */
  write_strings(dataptr->sockfd, dataptr->wbuf, 4,"GTC","0","0","O");/* openclose: O has no effect for retail customers according to the manual */
  write_integers(dataptr->sockfd, dataptr->wbuf, 2, 0, 0 );/* openclose, origin, orderref*/
  /*write_integers(sockfd, buf, 9, FALSE, \
   0, 0, \
   0, 0, \
   0, 0, \
   0, 0);*/
  write_integers(dataptr->sockfd, dataptr->wbuf, 9, TRUE/* transmit = TRUE, change this to FALSE for testing */, \
   0, FALSE, \
   FALSE, 0, \
   0, FALSE,\
   0,0);
  write_strings(dataptr->sockfd, dataptr->wbuf, 10,"","","","","","","","","",""); 
  /* sending a blank at the end to overcompensate */
  write_strings(dataptr->sockfd, dataptr->wbuf, 1,""); 
  printf("reduce position\n");
     /* need a print statement as below 
     DP(1,("PLACE_ORDER: %i, version: %i, orderid: %i",PLACE_ORDER, 13, orders[positions[i].ordersIndex].orderid));
     DP(1,("symbol: %s, sectype: %s, expiry: %s",positions[i].symbol, positions[i].sectype,positions[i].expiry));
     */
     /*no support for combo legs and share allocation*/
     /*Client.placeOrder(orders[positions[i].ordersIndex].orderId, positions[i].contract, orders[positions[i].ordersIndex]);*/
     send_close_window_message();
}

int place_order ( struct data * dataptr) {
  /* I can avoid this for loop and if if I place_order from price_check
   * I feel that it is better to have place_order separate, instead of making it dependent on price_check
   * Is this additional functionality worth the additional loop? I think so.. modularisation and 
   * can easily more complicated logic to place_order */
  int stkidx = 0, trdidx = 0, childtrdid = 0;
  dataptr->write_current_state = 1;
  for ( stkidx = 0; stkidx < dataptr->ssize - dataptr->sempty; stkidx++ ) {
    /* if trade_status == PLACEORDER then send order */
    if ( 0 > dataptr->stks[stkidx].current_trade_state ) continue; 
    else if ( PLACEORDER == dataptr->trds[dataptr->stks[stkidx].current_trade_state].status ) {
      send_order(dataptr, stkidx, dataptr->stks[stkidx].current_trade_state );
    }
    /* else if trade_status = CLOSED then */
    else if ( CLOSED == dataptr->trds[dataptr->stks[stkidx].current_trade_state].status ) {
    /* for each child */
      for ( trdidx = 0; trdidx < dataptr->trds[dataptr->stks[stkidx].current_trade_state].no_of_children; trdidx++ ) {
        childtrdid = dataptr->trds[dataptr->stks[stkidx].current_trade_state].children[trdidx] ;
    /*  what if >1 children has a PLACEORDER ???*/
        if ( PLACEORDER == dataptr->trds[childtrdid].status ) 
          send_order(dataptr, stkidx, childtrdid );
      } /* for ( trdidx = 0; trdidx < dataptr->trds[dataptr->stks[stkidx].current_trade_state].no_of_children; trdidx++ ) */
    }
  } /* for ( stkidx = 0; stkidx < dataptr->ssize - dataptr->sempty; stkidx++ ) */
  return 1;
} /* void place_order ( struct data * data) */


void assign_tick_price ( struct data * dataptr, int tickerid, int type, float price) {
   if ( 1 == type )  { 
      dataptr->stks[tickerid].bid = price;
   }
   else if ( 2 == type ) { 
      dataptr->stks[tickerid].ask = price;
   }
   else if ( 4 == type )  { 
      dataptr->stks[tickerid].last = price;
   }
}

int check_change_order_status ( struct trade * trdptr, int orderid, 
    				int quantity, char * action, int status) 
{ 
   if ( TWS_OPEN_ORDER == status &&
        orderid == trdptr->orderid &&
        quantity == abs(trdptr->quantity) && 
        ( ( 0 < trdptr->quantity && 0 == strcmp(action, "BUY") ) ||
          ( 0 > trdptr->quantity && 0 == strcmp(action, "SELL") ) 
	  ) 
      ) {
       trdptr->status = status;
       return 1;
   }
   if ( CLOSED == status &&
        orderid == trdptr->orderid &&
        /* quantity == abs(trdptr->quantity) &&  */
        ( ( 0 < trdptr->quantity && 0 == strcmp(action, "BOT") ) ||
          ( 0 > trdptr->quantity && 0 == strcmp(action, "SLD") ) ) 
      ) {
       trdptr->pending_execution = (0 == trdptr->pending_execution) ? trdptr->quantity - quantity: trdptr->pending_execution - quantity;
       if (trdptr->pending_execution) trdptr->status = PARTIALLY_CLOSED;
       else trdptr->status = status;
       return 1;
   }
return 0;
}

void change_order_status( struct data * dataptr, int status,
                int orderid, char * symbol,char * sectype, char * expiry,
                double strike, char * right,char * exchange, char * currency,
                char * localsymbol, char * action, int quantity){
  int i = 0, counter = 0, return_value = 0;
  struct stock * stkptr;
  struct trade * trdptr;
  for ( i=0; i < dataptr->ssize-dataptr->sempty; i++) {
    stkptr = &dataptr->stks[i];
    if ( 0 == strcmp(stkptr->symbol, symbol) &&
         0 == strcmp(stkptr->sectype, sectype) &&
         ('\0' == stkptr->expiry[0] || 0 == strcmp(stkptr->expiry, expiry) ) &&
	 ( !stkptr->strike || strike == stkptr->strike ) &&
         ('\0' == stkptr->right[0]  || 0 == strcmp(stkptr->right, right)   ) &&
         0 == strcmp(stkptr->exchange, exchange) &&
         0 == strcmp(stkptr->currency, currency) &&
	 (localsymbol && 0 == strcmp(stkptr->localsymbol, localsymbol) )
       ){
       trdptr = &dataptr->trds[stkptr->current_trade_state];
       if ( CLOSED == trdptr->status && 0 < trdptr->no_of_children ) {
           for (counter = 0; counter < trdptr->no_of_children; counter++) {
             if (1 == (return_value = check_change_order_status ( &dataptr->trds[trdptr->children[counter] ], orderid, quantity, action, status) ) ) {
	        if (CLOSED == status) stkptr->current_trade_state = trdptr->children[counter];
                break;
	     }
           } /* for (counter = 0; counter < trdptr->no_of_children; counter++)  */
       } /* if ( CLOSED == trdptr->status && 0 < trdptr->no_of_children )  */
       else if (1 == (return_value = check_change_order_status ( trdptr, orderid, quantity, action, status) ) ) {
         printf("updated order status\n");
       }
       if (0 == return_value) printf("could not find the concerned order\n");
       else dataptr->write_current_state = 1;
       break;
    } /* if ( 0 == (stkptr->symbol, symbol) && */
  } /* for ( i=0; i < dataptr->ssize-dataptr->sempty; i++) */
  if ( i == dataptr->ssize - dataptr->sempty ) {
    printf("Could not find the stock with the above open order\n");
  }
}


