
#include "main.h"

int ibl_token_scan(Scanner *s){
	uchar *cursor = s->cur;
std:
	s->tok = cursor;
/*!re2c
any	= [\000-\377];
anybutnull	= [\001-\377];
colon   = [ ]*[:]{1}[ ]*;
obrace   = [ ]*[{]{1}[ ]*;
cbrace   = [ ]*[}]{1}[ ]*;
indent   = [ ]*[-]{1}[ ]*;
null	= [\000];
*/

/*!re2c
	"/*"              { goto comment; }
        "-1" null         { RET(TOKNEGATIVE_MSG);}
        "1"[\000][0-1][\000]            { RET(TOKTICK_PRICEVER1);}
        "1"[\000]"2"[\000]              { RET(TOKTICK_PRICEVER2);}
        "1"[\000][3-9][0-9]*[\000]     { RET(TOKTICK_PRICEVER3);}
        "2"[\000]           { RET(TOKTICK_SIZE);}
        "3"[\000][0-1][\000]            { RET(TOKORDER_STATUSVER1);}
        "3"[\000]"2"[\000]            { RET(TOKORDER_STATUSVER2);}
        "3"[\000]"3"[\000]            { RET(TOKORDER_STATUSVER3);}
        "3"[\000]"4"[\000]            { RET(TOKORDER_STATUSVER4);}
        "3"[\000][5-9][0-9]*[\000]            { RET(TOKORDER_STATUSVER5);}
        "6"[\000][0-1][\000]            { RET(TOKACCT_VALUEVER1);}
        "6"[\000][2-9][0-9]*[\000]            { RET(TOKACCT_VALUEVER2);}
        "7"[\000][0-1][\000]            { RET(TOKPORTFOLIO_VALUEVER1);}
        "7"[\000]"2"[\000]            { RET(TOKPORTFOLIO_VALUEVER2);}
        "7"[\000]"3"[\000]            { RET(TOKPORTFOLIO_VALUEVER3);}
        "7"[\000][4-9[0-9]*[\000]            { RET(TOKPORTFOLIO_VALUEVER4);}
        "8"[\000]             { RET(TOKACCT_UPDATE_TIME);}
        "4"[\000][0-1][\000]            { RET(TOKERR_MSGVER1);}
        "4"[\000][2-9][0-9]*[\000]            { RET(TOKERR_MSGVER2);}
        "5"[\000][0-1][\000]            { RET(TOKOPEN_ORDERVER1);}
        "5"[\000]"2"[\000]            { RET(TOKOPEN_ORDERVER2);}
        "5"[\000]"3"[\000]            { RET(TOKOPEN_ORDERVER3);}
        "5"[\000]"4"[\000]            { RET(TOKOPEN_ORDERVER4);}
        "5"[\000]"5"[\000]            { RET(TOKOPEN_ORDERVER5);}
        "5"[\000]"6"[\000]            { RET(TOKOPEN_ORDERVER6);}
        "5"[\000]"7"[\000]            { RET(TOKOPEN_ORDERVER7);}
        "5"[\000][8-9][0-9]*[\000]            { RET(TOKOPEN_ORDERVER8);}
        "9"[\000]             { RET(TOKNEXT_VALID_ID);}
        "10"[\000]            { RET(TOKCONTRACT_DATA);}
        "11"[\000][0-1][\000]            { RET(TOKEXECUTION_DATAVER1);}
        "11"[\000]"2"[\000]            { RET(TOKEXECUTION_DATAVER2);}
        "11"[\000]"3"[\000]            { RET(TOKEXECUTION_DATAVER3);}
        "11"[\000][4-9][0-9]*[\000]            { RET(TOKEXECUTION_DATAVER4);}
        "12"[\000]            { RET(TOKMARKET_DEPTH);}
        "13"[\000]            { RET(TOKMARKET_DEPTH_L2);}
        "14"[\000]            { RET(TOKNEWS_BULLETINS);}
        "15"[\000]           { RET(TOKMANAGED_ACCTS);}
        "16"[\000]           { RET(TOKRECEIVE_FA);}
	/* I am getting some blank nulls at the end of some messages */
        [\000]           { RET(0);}
	[\r\n]
	    {
		if(cursor == s->eof) RET(EOF);
		s->pos = cursor; s->line++;
		goto std;
	    }
	any
	    {
		printf("unexpected character: %c-%i\n", *s->tok, atoi( (char *) s->tok));
		exit(EXIT_FAILURE); 
		goto std;
	    }
*/

comment: /*!re2c
	"*/"			{ goto std; }
	"\n"
	    {
		if(cursor == s->eof) RET(EOF);
		s->tok = s->pos = cursor; s->line++;
		goto comment;
	    }
        any			{ goto comment; }
*/
}

/*
main(){
    Scanner in;
    int t;
    memset((char*) &in, 0, sizeof(in));
    in.fd = 0;
    while((t = scan(&in)) != EOF){

	printf("%d\t%.*s\n", t, in.cur - in.tok, in.tok);
	printf("%d\n", t);

    }
    close(in.fd);
}
*/

/* Socket read max size: BUFSIZE - 2
 *   capture bytes recvd
 *   s->lim = s->eof = buf[bytes_recvd + 1]
 *   s->top set during initialisation to buf[BUFSIZE -1]
 *   
 *     I am doing the above to avoid fill() being called. It is called when s->lim - s->cur < 2
 *     In the above case, by adding 2 null characters at the end of the buffer, I am avoiding 
 *     the fill from being called
 *
 *     while loop:
 *       if there is a '\0' between ptr and n = num of bytes recvd 
 *         if NOT( s->lim - strchr(ptr,'\0') < 2 ) then 
 *           keep going
 *         else 
 *           refill or restack the buffer
 *           reset pointers (all to begin as in fill except s->lim, s->eof, s->top)
 *           if ptr == buf[0] i.e if the ptr is at the beginning of the buffer and still no NULL
 *           characters are found, then the size of the string received is > BUFSIZE
 *              exit(EXIT_FAILURE) and also an error message that the string size received > BUFSIZE
 *
 *     memset initialisation before each read: memset(buf[strlen(buf)],'\0',prev_bytes_recvd
 *     startlocation for the next socket read = buf[strlen(buf)]
 */



int ibl_value_scan(Scanner *s){
	uchar *cursor = s->cur;
std:
	s->tok = cursor;
/*!re2c
	"/*"                    			{ goto comment; }
	/* ([-+a-zA-Z_0-9.:\' \\\/])* null 		{RET(TOKVALUE);} */
	(anybutnull)* null 		{RET(TOKVALUE);}
	[\t\v\f]+
	    {
	    /*	printf("received space\n"); */
		goto std;
	    }
	[\r\n]
	    {
		if(cursor == s->eof) RET(EOF);
		s->pos = cursor; s->line++;
		goto std;
	    }
	any
	    {
		printf("unexpected character: %c-%i\n", *s->tok, atoi( (char *) s->tok));
		exit(EXIT_FAILURE);
		goto std;
	    }
*/

comment:

/*!re2c
	"*/"			{ goto std; }
	"\n"
	    {
		if(cursor == s->eof) RET(EOF);
		s->tok = s->pos = cursor; s->line++;
		goto comment;
	    }
        any			{ goto comment; }
*/
}



