

%extra_argument { struct data * dataptr}
%name ibparse

%token_type {struct tokenvalue}
%include {   
#include "main.h"
}  

   
%syntax_error {  
  DP(1,("syntax error"));
  /* backtracking: reset the scannerptr->cur back to the previous token  */
  dataptr->scanner.cur = dataptr->scanner.tok;
  dataptr->cptrn = 0;
  exit(EXIT_FAILURE);
}   
   
/* leaving this as multiple messages just in case  
 * I am not able to capture the ond of a message properly  */
program	 ::= messages.
messages ::= messages message.
messages ::= message.
message  ::= TOKTICK_PRICEVER1(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F).
  {
    DP(1,("%s: tick_pricever1: %i version:%i, tickerId:%i, tickType:%i,price:%f",
  	dataptr->account,atoi(C.value), atoi(&C.value[ strlen(C.value) + 1 ]), atoi(D.value) ,    atoi(E.value) ,   atof(F.value)));
     assign_tick_price( dataptr, atoi(D.value), atoi(E.value), atof(F.value) );
  
  }
message  ::= TOKTICK_PRICEVER2(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G).
  {
    DP(1,("%s: tick_pricever2: %i version:%i, tickerId:%i, tickType:%i,price:%f,size:%i",
  	dataptr->account,atoi(C.value), atoi(&C.value[ strlen(C.value) + 1 ]), atoi(D.value) ,    atoi(E.value) ,   atof(F.value) , atoi(G.value) ));
     assign_tick_price( dataptr, atoi(D.value), atoi(E.value), atof(F.value) );
  }
message  ::= TOKTICK_PRICEVER3(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H).
  {
    DP(1,("%s: tick_pricever3: %i version:%i, tickerId:%i, tickType:%i,price:%f,size:%i,canAutoExecute:%i",
  	dataptr->account,atoi(C.value), atoi(&C.value[ strlen(C.value) + 1 ]), atoi(D.value) ,    atoi(E.value) ,   atof(F.value) , atoi(G.value) , atoi(H.value)));
    assign_tick_price( dataptr, atoi(D.value), atoi(E.value), atof(F.value) );
  }
message  ::= TOKTICK_SIZE TOKVALUE(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F).
  {
  DP(1,("%s: tick_size: version:%i,tickerId:%i,tickType:%i,size:%i ", dataptr->account,atoi(C.value) , atoi(D.value) ,   atoi(E.value) ,  atoi(F.value) ));
  /* m_eWrapper.tickSizetickerId,tickType,size */
  /* break */
  }
message  ::= TOKORDER_STATUSVER1(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H).
  {
  DP(1,("%s: order_status: %i, version:%i,Id:%i,status:%s,filled:%i,\
          remaining:%i,avgFillPrice:%f",\
          dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , atoi(F.value) , \
          atoi(G.value) ,        atof(H.value) ));  
  }
message  ::= TOKORDER_STATUSVER2(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I).
  {
  DP(1,("%s: order_status: %i, version:%i,Id:%i,status:%s,filled:%i,\
          remaining:%i,avgFillPrice:%f,permid:%i",\
          dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , atoi(F.value) , \
          atoi(G.value) ,        atof(H.value), atoi(I.value) ));  
  }
message  ::= TOKORDER_STATUSVER3(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J).
  {
  DP(1,("%s: order_status: %i, version:%i,Id:%i,status:%s,filled:%i,\
          remaining:%i,avgFillPrice:%f,permId:%i,parentId:%i",\
          dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , atoi(F.value) , \
          atoi(G.value) ,        atof(H.value) ,    atoi(I.value) , atoi(J.value) ));
  }
message  ::= TOKORDER_STATUSVER4(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K).
  {
  DP(1,("%s: order_status: %i, version:%i,Id:%i,status:%s,filled:%i,\
          remaining:%i,avgFillPrice:%f,permId:%i,parentId:%i,\
          lastFillPrice:%f", \
          dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , atoi(F.value) , \
          atoi(G.value) ,        atof(H.value) ,    atoi(I.value) , atoi(J.value),\
          atof(K.value)  ));  
  }
message  ::= TOKORDER_STATUSVER5(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L).
  {
  DP(1,("%s: order_status: %i, version:%i,Id:%i,status:%s,filled:%i,\
          remaining:%i,avgFillPrice:%f,permId:%i,parentId:%i,\
          lastFillPrice:%f,clientId:%i", \
          dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , atoi(F.value) , \
          atoi(G.value) ,        atof(H.value) ,    atoi(I.value) , atoi(J.value) ,     \
          atof(K.value) ,        atoi(L.value) ));  
  }
message  ::= TOKACCT_VALUEVER1(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F).
  {
  DP(1,("%s: acct_value: %i, version:%i,key:%s,val:%s,cur:%s", dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), D.value , E.value ,   F.value ));
  }
message  ::= TOKACCT_VALUEVER2(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G).
  {
  DP(1,("%s: acct_value: %i, version:%i,key:%s,val:%s,cur:%s,accountName:%s", dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), D.value , E.value ,   F.value, G.value ));
  }

message  ::= TOKPORTFOLIO_VALUEVER1(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M).
  {
  DP(1,("%s: portfolio_value:%i, version:%i,contractm_symbol:%s ,contractm_secType:%s ,contractm_expiry:%s ,\
         contractm_strike:%f ,contractm_right:%s ,contractm_currency:%s ,\
         position:%i ,marketPrice:%f ,marketValue:%f",\
         dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), D.value , E.value , F.value ,\
         atof(G.value) , H.value , I.value ,\
         atoi(K.value) , atof(L.value) , atof(M.value) ));
  }
message  ::= TOKPORTFOLIO_VALUEVER2(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) .
  {
  DP(1,("%s: portfolio_value:%i, version:%i,contractm_symbol:%s ,contractm_secType:%s ,contractm_expiry:%s ,\
         contractm_strike:%f ,contractm_right:%s ,contractm_currency:%s ,contractm_localSymbol:%s ,\
         position:%i ,marketPrice:%f ,marketValue:%f",\
         dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), D.value , E.value , F.value ,\
         atof(G.value) , H.value , I.value , J.value ,\
         atoi(K.value) , atof(L.value) , atof(M.value) ));
  }
message  ::= TOKPORTFOLIO_VALUEVER3(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P).
  {
  DP(1,("%s: portfolio_value:%i, version:%i,contractm_symbol:%s ,contractm_secType:%s ,contractm_expiry:%s ,\
         contractm_strike:%f ,contractm_right:%s ,contractm_currency:%s ,contractm_localSymbol:%s ,\
         position:%i ,marketPrice:%f ,marketValue:%f ,averageCost:%f ,\
         unrealizedPNL:%f ,realizedPNL:%f",\
         dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), D.value , E.value , F.value ,\
         atof(G.value) , H.value , I.value , J.value ,\
         atoi(K.value) , atof(L.value) , atof(M.value) , atof(N.value) ,\
         atof(O.value) , atof(P.value)));
  }
message  ::= TOKPORTFOLIO_VALUEVER4(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q).
  {
  DP(1,("%s: portfolio_value:%i, version:%i,contractm_symbol:%s ,contractm_secType:%s ,contractm_expiry:%s ,\
         contractm_strike:%f ,contractm_right:%s ,contractm_currency:%s ,contractm_localSymbol:%s ,\
         position:%i ,marketPrice:%f ,marketValue:%f ,averageCost:%f ,\
         unrealizedPNL:%f ,realizedPNL:%f ,accountName:%s",\
         dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), D.value , E.value , F.value ,\
         atof(G.value) , H.value , I.value , J.value ,\
         atoi(K.value) , atof(L.value) , atof(M.value) , atof(N.value) ,\
         atof(O.value) , atof(P.value) , Q.value));
  }
message  ::= TOKACCT_UPDATE_TIME TOKVALUE(C) TOKVALUE(D).
  {
  DP(1,("%s: acct_update_time: version:%i,timestamp:%s", dataptr->account,atoi(C.value), D.value));
  }
message  ::= TOKERR_MSGVER1(C) TOKVALUE(D).
  {
  DP(1,("%s: err_msg:%i, version:%i,errorMsg:%s",\
         dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), D.value));
  }
message  ::= TOKERR_MSGVER2(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F).  
  {
  DP(1,("%s: err_msg:%i,version:%i,id:%i,errorCode:%i,errorMsg:%s",\
         dataptr->account,atoi(C.value), atoi(&C.value[strlen(C.value) + 1]), atoi(D.value), atoi(E.value) , F.value)); 
    if (1100 == atoi(E.value)) dataptr->close_connection = 1;
  }

message  ::= TOKOPEN_ORDERVER1(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V) TOKVALUE(W).
  {
  /* breaking this into 2 print statements to avoid the error: ibp.y:84: warning: string length `669' is greater than the length `509' ISO C89 compilers are required to support */
   DP(1,("%s: open_orderver1:%i, version:%i,orderm_orderId:%i,contractm_symbol:%s,contractm_secType:%s,\
          contractm_expiry:%s,contractm_strike:%f,contractm_right:%s,contractm_exchange:%s,\
  	contractm_currency:%s",\
          dataptr->account,atoi(C.value),  atoi(&C.value[strlen(C.value) + 1]),atoi(D.value) , E.value , F.value,\
  	G.value , atof(H.value) , I.value , J.value ,\
  	K.value  ));
   DP(1,("orderm_action:%s,orderm_totalQuantity:%i,\
  	orderm_orderType:%s,orderm_lmtPrice:%f,orderm_auxPrice:%f,orderm_tif:%s,\
  	orderm_ocaGroup:%s,orderm_account:%s,orderm_openClose:%s,orderm_origin:%i,\
  	orderm_orderRef:%s",\
  	M.value , atoi(N.value) ,\
  	O.value , atof(P.value) , atof(Q.value) , R.value ,\
  	S.value , T.value , U.value, atoi(V.value) ,\
  	W.value ));

   change_order_status(dataptr, TWS_OPEN_ORDER,
   		 atoi(D.value) , (char *)&E.value ,(char *) &F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 NULL,  (char *)&M.value , atoi(N.value)  );
  }
message  ::= TOKOPEN_ORDERVER2(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V) TOKVALUE(W).
  {
  /* breaking this into 2 print statements to avoid the error: ibp.y:84: warning: string length `669' is greater than the length `509' ISO C89 compilers are required to support */
   DP(1,("%s: open_orderver2:%i, version:%i,orderm_orderId:%i,contractm_symbol:%s,contractm_secType:%s,\
          contractm_expiry:%s,contractm_strike:%f,contractm_right:%s,contractm_summarym_exchange:%s,\
  	contractm_currency:%s,contractm_localSymbol:%s",\
          dataptr->account,atoi(C.value),  atoi(&C.value[strlen(C.value) + 1]),atoi(D.value) , E.value , F.value,\
  	G.value , atof(H.value) , I.value , J.value ,\
  	K.value , L.value ));
   DP(1,("orderm_action:%s,orderm_totalQuantity:%i,\
  	orderm_orderType:%s,orderm_lmtPrice:%f,orderm_auxPrice:%f,orderm_tif:%s,\
  	orderm_ocaGroup:%s,orderm_account:%s,orderm_openClose:%s,orderm_origin:%i,\
  	orderm_orderRef:%s",\
  	M.value , atoi(N.value) ,\
  	O.value , atof(P.value) , atof(Q.value) , R.value ,\
  	S.value , T.value , U.value, atoi(V.value) ,\
  	W.value ));

   change_order_status(dataptr, TWS_OPEN_ORDER,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&M.value , atoi(N.value)  );
  }
message  ::= TOKOPEN_ORDERVER3(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V) TOKVALUE(W) TOKVALUE(X).
  {
  /* breaking this into 2 print statements to avoid the error: ibp.y:84: warning: string length `669' is greater than the length `509' ISO C89 compilers are required to support */
   DP(1,("%s: open_orderver3:%i, version:%i,orderm_orderId:%i,contractm_symbol:%s,contractm_secType:%s,\
          contractm_expiry:%s,contractm_strike:%f,contractm_right:%s,contractm_summarym_exchange:%s,\
  	contractm_currency:%s,contractm_localSymbol:%s",\
          dataptr->account,atoi(C.value),  atoi(&C.value[strlen(C.value) + 1]),atoi(D.value) , E.value , F.value,\
  	G.value , atof(H.value) , I.value , J.value ,\
  	K.value , L.value ));
   DP(1,("orderm_action:%s,orderm_totalQuantity:%i,\
  	orderm_orderType:%s,orderm_lmtPrice:%f,orderm_auxPrice:%f,orderm_tif:%s,\
  	orderm_ocaGroup:%s,orderm_account:%s,orderm_openClose:%s,orderm_origin:%i,\
  	orderm_orderRef:%s,orderm_clientId:%i",\
  	M.value , atoi(N.value) ,\
  	O.value , atof(P.value) , atof(Q.value) , R.value ,\
  	S.value , T.value , U.value, atoi(V.value) ,\
  	W.value ,atoi(X.value) ));

   change_order_status(dataptr, TWS_OPEN_ORDER,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&M.value , atoi(N.value)  );
  }
message  ::= TOKOPEN_ORDERVER4(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V) TOKVALUE(W) TOKVALUE(X) TOKVALUE(Y) TOKVALUE(Z) TOKVALUE(AA) TOKVALUE(AB).
  {
  /* breaking this into 2 print statements to avoid the error: ibp.y:84: warning: string length `669' is greater than the length `509' ISO C89 compilers are required to support */
   DP(1,("%s: open_orderver4:%i, version:%i,orderm_orderId:%i,contractm_symbol:%s,contractm_secType:%s,\
          contractm_expiry:%s,contractm_strike:%f,contractm_right:%s,contractm_summarym_exchange:%s,\
  	contractm_currency:%s,contractm_localSymbol:%s",\
          dataptr->account,atoi(C.value),  atoi(&C.value[strlen(C.value) + 1]),atoi(D.value) , E.value , F.value,\
  	G.value , atof(H.value) , I.value , J.value ,\
  	K.value , L.value ));
   DP(1,("orderm_action:%s,orderm_totalQuantity:%i,\
  	orderm_orderType:%s,orderm_lmtPrice:%f,orderm_auxPrice:%f,orderm_tif:%s,\
  	orderm_ocaGroup:%s,orderm_account:%s,orderm_openClose:%s,orderm_origin:%i,\
  	orderm_orderRef:%s,orderm_clientId:%i,orderm_permId:%i,orderm_ignoreRth:%i,\
  	orderm_hidden:%i,orderm_discretionaryAmt:%f",\
  	M.value , atoi(N.value) ,\
  	O.value , atof(P.value) , atof(Q.value) , R.value ,\
  	S.value , T.value , U.value, atoi(V.value) ,\
  	W.value ,atoi(X.value) , atoi(Y.value) ,atoi(Z.value) ,\
  	atoi(AA.value) ,atof(AB.value) ));

   change_order_status(dataptr, TWS_OPEN_ORDER,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&M.value , atoi(N.value)  );
  }
message  ::= TOKOPEN_ORDERVER5(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V) TOKVALUE(W) TOKVALUE(X) TOKVALUE(Y) TOKVALUE(Z) TOKVALUE(AA) TOKVALUE(AB) TOKVALUE(AC).
  {
  /* breaking this into 2 print statements to avoid the error: ibp.y:84: warning: string length `669' is greater than the length `509' ISO C89 compilers are required to support */
   DP(1,("%s: open_orderver5:%i, version:%i,orderm_orderId:%i,contractm_symbol:%s,contractm_secType:%s,\
          contractm_expiry:%s,contractm_strike:%f,contractm_right:%s,contractm_summarym_exchange:%s,\
  	contractm_currency:%s,contractm_localSymbol:%s",\
          dataptr->account,atoi(C.value),  atoi(&C.value[strlen(C.value) + 1]),atoi(D.value) , E.value , F.value,\
  	G.value , atof(H.value) , I.value , J.value ,\
  	K.value , L.value ));
   DP(1,("orderm_action:%s,orderm_totalQuantity:%i,\
  	orderm_orderType:%s,orderm_lmtPrice:%f,orderm_auxPrice:%f,orderm_tif:%s,\
  	orderm_ocaGroup:%s,orderm_account:%s,orderm_openClose:%s,orderm_origin:%i,\
  	orderm_orderRef:%s,orderm_clientId:%i,orderm_permId:%i,orderm_ignoreRth:%i,\
  	orderm_hidden:%i,orderm_discretionaryAmt:%f,orderm_goodAfterTime:%s",\
  	M.value , atoi(N.value) ,\
  	O.value , atof(P.value) , atof(Q.value) , R.value ,\
  	S.value , T.value , U.value, atoi(V.value) ,\
  	W.value ,atoi(X.value) , atoi(Y.value) ,atoi(Z.value) ,\
  	atoi(AA.value) ,atof(AB.value) ,AC.value ));

   change_order_status(dataptr, TWS_OPEN_ORDER,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&M.value , atoi(N.value)  );
  }
message  ::= TOKOPEN_ORDERVER6(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V) TOKVALUE(W) TOKVALUE(X) TOKVALUE(Y) TOKVALUE(Z) TOKVALUE(AA) TOKVALUE(AB) TOKVALUE(AC) TOKVALUE(AD).
  {
  /* breaking this into 2 print statements to avoid the error: ibp.y:84: warning: string length `669' is greater than the length `509' ISO C89 compilers are required to support */
   DP(1,("%s: open_orderver6:%i, version:%i,orderm_orderId:%i,contractm_symbol:%s,contractm_secType:%s,\
          contractm_expiry:%s,contractm_strike:%f,contractm_right:%s,contractm_summarym_exchange:%s,\
  	contractm_currency:%s,contractm_localSymbol:%s",\
          dataptr->account,atoi(C.value),  atoi(&C.value[strlen(C.value) + 1]),atoi(D.value) , E.value , F.value,\
  	G.value , atof(H.value) , I.value , J.value ,\
  	K.value , L.value ));
   DP(1,("orderm_action:%s,orderm_totalQuantity:%i,\
  	orderm_orderType:%s,orderm_lmtPrice:%f,orderm_auxPrice:%f,orderm_tif:%s,\
  	orderm_ocaGroup:%s,orderm_account:%s,orderm_openClose:%s,orderm_origin:%i,\
  	orderm_orderRef:%s,orderm_clientId:%i,orderm_permId:%i,orderm_ignoreRth:%i,\
  	orderm_hidden:%i,orderm_discretionaryAmt:%f,orderm_goodAfterTime:%s,orderm_sharesAllocation:%s",\
  	M.value , atoi(N.value) ,\
  	O.value , atof(P.value) , atof(Q.value) , R.value ,\
  	S.value , T.value , U.value, atoi(V.value) ,\
  	W.value ,atoi(X.value) , atoi(Y.value) ,atoi(Z.value) ,\
  	atoi(AA.value) ,atof(AB.value) ,AC.value,AD.value));

   change_order_status(dataptr, TWS_OPEN_ORDER,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&M.value , atoi(N.value)  );
  }
message  ::= TOKOPEN_ORDERVER7(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V) TOKVALUE(W) TOKVALUE(X) TOKVALUE(Y) TOKVALUE(Z) TOKVALUE(AA) TOKVALUE(AB) TOKVALUE(AC) TOKVALUE(AD) TOKVALUE(AE) TOKVALUE(AF) TOKVALUE(AG) TOKVALUE(AH).
  {
  /* breaking this into 2 print statements to avoid the error: ibp.y:84: warning: string length `669' is greater than the length `509' ISO C89 compilers are required to support */
   DP(1,("%s: open_orderver7:%i, version:%i,orderm_orderId:%i,contractm_symbol:%s,contractm_secType:%s,\
          contractm_expiry:%s,contractm_strike:%f,contractm_right:%s,contractm_summarym_exchange:%s,\
  	contractm_currency:%s,contractm_localSymbol:%s",\
          dataptr->account,atoi(C.value),  atoi(&C.value[strlen(C.value) + 1]),atoi(D.value) , E.value , F.value,\
  	G.value , atof(H.value) , I.value , J.value ,\
  	K.value , L.value ));
   DP(1,("orderm_action:%s,orderm_totalQuantity:%i,\
  	orderm_orderType:%s,orderm_lmtPrice:%f,orderm_auxPrice:%f,orderm_tif:%s,\
  	orderm_ocaGroup:%s,orderm_account:%s,orderm_openClose:%s,orderm_origin:%i,\
  	orderm_orderRef:%s,orderm_clientId:%i,orderm_permId:%i,orderm_ignoreRth:%i,\
  	orderm_hidden:%i,orderm_discretionaryAmt:%f,orderm_goodAfterTime:%s,orderm_sharesAllocation:%s,\
  	orderm_faGroup:%s,orderm_faMethod:%s,orderm_faPercentage:%s,orderm_faProfile:%s",\
  	M.value , atoi(N.value) ,\
  	O.value , atof(P.value) , atof(Q.value) , R.value ,\
  	S.value , T.value , U.value, atoi(V.value) ,\
  	W.value ,atoi(X.value) , atoi(Y.value) ,atoi(Z.value) ,\
  	atoi(AA.value) ,atof(AB.value) ,AC.value ,AD.value ,\
  	AE.value ,AF.value ,AG.value ,AH.value)); 

   change_order_status(dataptr, TWS_OPEN_ORDER,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&M.value , atoi(N.value)  );
  }
message  ::= TOKOPEN_ORDERVER8(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V) TOKVALUE(W) TOKVALUE(X) TOKVALUE(Y) TOKVALUE(Z) TOKVALUE(AA) TOKVALUE(AB) TOKVALUE(AC) TOKVALUE(AD) TOKVALUE(AE) TOKVALUE(AF) TOKVALUE(AG) TOKVALUE(AH) TOKVALUE(AI).
  {
  /* breaking this into 2 print statements to avoid the error: ibp.y:84: warning: string length `669' is greater than the length `509' ISO C89 compilers are required to support */
   DP(1,("%s: open_orderver7:%i, version:%i,orderm_orderId:%i,contractm_symbol:%s,contractm_secType:%s,\
          contractm_expiry:%s,contractm_strike:%f,contractm_right:%s,contractm_summarym_exchange:%s,\
  	contractm_currency:%s,contractm_localSymbol:%s",\
          dataptr->account,atoi(C.value),  atoi(&C.value[strlen(C.value) + 1]),atoi(D.value) , E.value , F.value,\
  	G.value , atof(H.value) , I.value , J.value ,\
  	K.value , L.value ));
   DP(1,("orderm_action:%s,orderm_totalQuantity:%i,\
  	orderm_orderType:%s,orderm_lmtPrice:%f,orderm_auxPrice:%f,orderm_tif:%s,\
  	orderm_ocaGroup:%s,orderm_account:%s,orderm_openClose:%s,orderm_origin:%i,\
  	orderm_orderRef:%s,orderm_clientId:%i,orderm_permId:%i,orderm_ignoreRth:%i,\
  	orderm_hidden:%i,orderm_discretionaryAmt:%f,orderm_goodAfterTime:%s,orderm_sharesAllocation:%s,\
  	orderm_faGroup:%s,orderm_faMethod:%s,orderm_faPercentage:%s,orderm_faProfile:%s,\
	orderm_goodtilldate:%s",\
  	M.value , atoi(N.value) ,\
  	O.value , atof(P.value) , atof(Q.value) , R.value ,\
  	S.value , T.value , U.value, atoi(V.value) ,\
  	W.value ,atoi(X.value) , atoi(Y.value) ,atoi(Z.value) ,\
  	atoi(AA.value) ,atof(AB.value) ,AC.value ,AD.value ,\
  	AE.value ,AF.value ,AG.value ,AH.value,\
	AI.value)); 

   change_order_status(dataptr, TWS_OPEN_ORDER,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&M.value , atoi(N.value)  );
  }
message  ::= TOKNEXT_VALID_ID TOKVALUE(C) TOKVALUE(D).
  {
    DP(1,("%s: next_valid_id: version:%i,orderid:%i", dataptr->account,atoi(C.value), atoi(D.value))); 
    dataptr->orderid = atoi(D.value);
  }
  
message  ::= TOKCONTRACT_DATA TOKVALUE(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R).
  {
  DP(1,("%s: contract_data: version:%i,contractm_symbol:%s ,contractm_secType:%s ,contractm_expiry:%s,\
         contractm_strike:%f ,contractm_right:%s ,contractm_summarym_exchange:%s ,contractm_currency:%s,\
         contractm_localSymbol:%s ,contractm_marketName:%s ,contractm_tradingClass:%s ,contractm_conid:%s ,\
         contractm_minTick:%f ,contractm_multiplier:%s ,contractm_orderTypes:%s ,contractm_validExchanges:%s",\
         dataptr->account,atoi(C.value), D.value , E.value , F.value ,\
         atof(G.value) , H.value , I.value , J.value ,\
         K.value , L.value , M.value , N.value ,\
         atof(O.value) , P.value , Q.value , R.value));
  
     for (dataptr->cstk = 0; dataptr->cstk < dataptr->ssize - dataptr->sempty ; dataptr->cstk++) {
       if (0 == strcmp(K.value, dataptr->stks[dataptr->cstk].localsymbol)) break;
     }
     if ( dataptr->ssize - dataptr->sempty == dataptr->cstk) {
       DP(1,("%s: stock not found in strategy",dataptr->account)); 
     }
     else {
       strcpy(dataptr->stks[dataptr->cstk].symbol,D.value);
       strcpy(dataptr->stks[dataptr->cstk].sectype,E.value);
       strcpy(dataptr->stks[dataptr->cstk].expiry,F.value);
       dataptr->stks[dataptr->cstk].strike = atof(G.value);
       strcpy(dataptr->stks[dataptr->cstk].right,H.value);
       strcpy(dataptr->stks[dataptr->cstk].exchange,I.value);
       strcpy(dataptr->stks[dataptr->cstk].currency,J.value);
       strcpy(dataptr->stks[dataptr->cstk].multiplier,P.value);
     }
     
  }
message  ::= TOKEXECUTION_DATAVER1(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S).
  {
  DP(1,("%s: execution_data:%i, version:%i,orderId:%i ,contractm_symbol:%s ,contractm_secType:%s,\
         contractm_expiry:%s ,contractm_strike:%f ,contractm_right:%s ,contractm_summarym_exchange:%s,\
         contractm_currency:%s ,contractm_localSymbol:%s ,execm_execId:%s ,execm_time:%s,\
         execm_acctNumber:%s ,execm_exchange:%s ,execm_side:%s ,execm_shares:%i,\
         execm_price:%f",\
         dataptr->account,atoi(C.value),atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , F.value,\
         G.value , atof(H.value) , I.value , J.value ,\
         K.value , L.value , M.value , N.value ,\
         O.value , P.value , Q.value , atoi(R.value) ,\
         atof(S.value)));
	 
   change_order_status(dataptr, CLOSED,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&Q.value , atoi(R.value) );
  }
message  ::= TOKEXECUTION_DATAVER2(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T).
  {
  DP(1,("%s: execution_data:%i, version:%i,orderId:%i ,contractm_symbol:%s ,contractm_secType:%s,\
         contractm_expiry:%s ,contractm_strike:%f ,contractm_right:%s ,contractm_summarym_exchange:%s,\
         contractm_currency:%s ,contractm_localSymbol:%s ,execm_execId:%s ,execm_time:%s,\
         execm_acctNumber:%s ,execm_exchange:%s ,execm_side:%s ,execm_shares:%i,\
         execm_price:%f ,execm_permId:%i",\
         dataptr->account,atoi(C.value),atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , F.value,\
         G.value , atof(H.value) , I.value , J.value ,\
         K.value , L.value , M.value , N.value ,\
         O.value , P.value , Q.value , atoi(R.value) ,\
         atof(S.value) , atoi(T.value)));

   change_order_status(dataptr, CLOSED,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&Q.value , atoi(R.value) );
  }
message  ::= TOKEXECUTION_DATAVER3(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U).
  {
  DP(1,("%s: execution_data:%i, version:%i,orderId:%i ,contractm_symbol:%s ,contractm_secType:%s,\
         contractm_expiry:%s ,contractm_strike:%f ,contractm_right:%s ,contractm_summarym_exchange:%s,\
         contractm_currency:%s ,contractm_localSymbol:%s ,execm_execId:%s ,execm_time:%s,\
         execm_acctNumber:%s ,execm_exchange:%s ,execm_side:%s ,execm_shares:%i,\
         execm_price:%f ,execm_permId:%i ,execm_clientId:%i",\
         dataptr->account,atoi(C.value),atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , F.value,\
         G.value , atof(H.value) , I.value , J.value ,\
         K.value , L.value , M.value , N.value ,\
         O.value , P.value , Q.value , atoi(R.value) ,\
         atof(S.value) , atoi(T.value) , atoi(U.value)));

   change_order_status(dataptr, CLOSED,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&Q.value , atoi(R.value) );
  }
message  ::= TOKEXECUTION_DATAVER4(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J) TOKVALUE(K) TOKVALUE(L) TOKVALUE(M) TOKVALUE(N) TOKVALUE(O) TOKVALUE(P) TOKVALUE(Q) TOKVALUE(R) TOKVALUE(S) TOKVALUE(T) TOKVALUE(U) TOKVALUE(V).
  {
  DP(1,("%s: execution_data:%i, version:%i,orderId:%i ,contractm_symbol:%s ,contractm_secType:%s,\
         contractm_expiry:%s ,contractm_strike:%f ,contractm_right:%s ,contractm_summarym_exchange:%s,\
         contractm_currency:%s ,contractm_localSymbol:%s ,execm_execId:%s ,execm_time:%s,\
         execm_acctNumber:%s ,execm_exchange:%s ,execm_side:%s ,execm_shares:%i,\
         execm_price:%f ,execm_permId:%i ,execm_clientId:%i ,execm_liquidation:%i",\
         dataptr->account,atoi(C.value),atoi(&C.value[strlen(C.value) + 1]), atoi(D.value) , E.value , F.value,\
         G.value , atof(H.value) , I.value , J.value ,\
         K.value , L.value , M.value , N.value ,\
         O.value , P.value , Q.value , atoi(R.value) ,\
         atof(S.value) , atoi(T.value) , atoi(U.value) , atoi(V.value)));

   change_order_status(dataptr, CLOSED,
   		 atoi(D.value) , (char *)&E.value , (char *)&F.value, (char *)&G.value ,
   	         atof(H.value) , (char *)&I.value ,(char *)&J.value , (char *)&K.value,
		 (char *)&L.value,  (char *)&Q.value , atoi(R.value) );
  }
  
message  ::= TOKMARKET_DEPTH TOKVALUE(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I).
  {
  DP(1,("%s: market_depth: version:%i,Id:%i ,position:%i ,operation:%i ,side:%i ,price:%f ,size:%i", dataptr->account,atoi(C.value), atoi(D.value) , atoi(E.value) , atoi(F.value) , atoi(G.value) , atof(H.value) , atoi(I.value) ));
  }
  
message  ::= TOKMARKET_DEPTH_L2 TOKVALUE(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G) TOKVALUE(H) TOKVALUE(I) TOKVALUE(J).
   { 
   DP(1,("%s: market_depth_l2: version:%i,Id:%i ,position:%i ,marketMaker:%s,operation:%i ,side:%i ,price:%f ,size:%i", dataptr->account,atoi(C.value) , atoi(D.value) , atoi(E.value) , F.value , atoi(G.value) , atoi(H.value) , atof(I.value) , atoi(J.value) )); 
   } 
  
message  ::= TOKNEWS_BULLETINS TOKVALUE(C) TOKVALUE(D) TOKVALUE(E) TOKVALUE(F) TOKVALUE(G).
  {
  DP(1,("%s: news_bulletins: version:%i,newsMsgId:%i ,newsMsgType:%i ,newsMessage:%s ,originatingExch:%s" , dataptr->account,atoi(C.value) , atoi(D.value) , atoi(E.value) , F.value , G.value));
  }
message  ::= TOKMANAGED_ACCTS TOKVALUE(C) TOKVALUE(D).
  {
  DP(1,("%s: managed_accts: version:%i,accountsList:%s", dataptr->account,atoi(C.value), D.value));
  }
message  ::= TOKRECEIVE_FA TOKVALUE(C) TOKVALUE(D) TOKVALUE(E).
  {
  DP(1,("%s: receive_fa: version:%i,faDataType:%i,xml:%s", dataptr->account,atoi(C.value),   atoi(D.value),      E.value));
  }
message  ::= TOKNEGATIVE_MSG. {
    DP(1,("negative message"));
  }
  
