
#include "main.h"
/* checker does not work with epoll. try valgrind or memprof */

int main() {
  struct data * dataptr = (struct data *) calloc(NUMACCTS, sizeof(struct data));
  int epollfd = 0, actidx = 0, sockets_with_events = 0, i = 0;
  /* struct sockaddr_in their_addr;  connector's address information */
  /* struct timeval tv; time value structure for sleep */
  char *child_data_dir = strcat(getcwd((char *)calloc(100, sizeof(char)), 99), "/ticks");
  struct epoll_event event_to_register;
  struct epoll_event *recvd_events_ptr;
  long int prev_time_data_recvd = 0;
  int market_open = 0, email_state = 0;

  DB(10,"main");
  mkdir(child_data_dir,DIR_MODE);
  memset( (char *) dataptr, '\0', sizeof(struct data) * NUMACCTS);
  /* parser and lexer initializations from here */
  dataptr[0].parser = (void *) ibparseAlloc (malloc);
  dataptr[1].parser = (void *) ibparseAlloc (malloc);
  /* ibparseFree(data[i].parser, free ); */

  /* set account data */
  dataptr[0].port = 7496;
  strcpy(dataptr[0].account, "U111111"); /* ib user account 1 */
  dataptr[1].port = 7497;
  strcpy(dataptr[1].account, "U222222"); /* ib user account 2 */

   /* test_ibparser(&dataptr[0]);  */
   /* exit(EXIT_FAILURE);  */

  /* create epoll struct */
  epollfd = epoll_create (NUMACCTS + 2);
  recvd_events_ptr = calloc(NUMACCTS + 2, sizeof(struct epoll_event));
  /* memset( (char *) recvd_events_ptr, '\0', sizeof(struct epoll_event)* (NUMACCTS+2) ); */
  memset( (char *) &event_to_register, '\0', sizeof(struct epoll_event) );
  /* parser and lexer initializations from here */

  /* while loop:
   * 1. read strategy
   * 2. get_ib_patterns
   * 3. create or recreate sockets and attach to epoll
   * 4. on epoll notification
   * 	a.  read data to concerned buffer
   * 	b.  parse data from concerned buffer
   * 	c.  price check ( only during market open)
   * 	d.  place any orders  ( only during market open)
   * */


  while (1){
    /* reread strategy if file was changed  */
    read_strategy(dataptr);

    /* connect & initialize
     * get contract details
     * request market data
     * place order
     * disconnect*/
    for (actidx = 0; actidx < NUMACCTS; actidx++) {
      if ( 0 == dataptr[actidx].sockfd) connect_to_ib (&dataptr[actidx], &epollfd, &event_to_register, recvd_events_ptr);
      if ( 1 == dataptr[actidx].close_connection || MAXINACTIVETIME < difftime( dataptr[actidx].time_data_recvd, prev_time_data_recvd ) ) {
         close_connection(&dataptr[actidx],NULL);
      }
    } /* for (actidx = 0; actidx < NUMACCTS; actidx++)  */


    DP(10,("about to start epoll_wait\n"));
    /* epoll_wait returns the number of sockets with events on them
     * adding 2 more fd's just in case the closed one takes some time to be removed
     * hardcoding the timeout to 1sec */
    sockets_with_events = epoll_wait( epollfd, recvd_events_ptr, NUMACCTS + 2, TIMEOUT );
    DP(10,("events received from epoll_wait: %i \n", i));

    /* can I use u32 to store the actidx of the data that the sockfd pertains to? NO, struct's a union */
    for (i = 0; i < sockets_with_events; i++) {
        /* printf("received %i bytes on %i: event id: 0x%x\n",a,events[n].data.fd,events[n].events); */
        actidx = 0;
	/* do I need this below */
	if ( -1 == recvd_events_ptr[i].data.fd ) continue;
        while ( dataptr[actidx].sockfd != recvd_events_ptr[i].data.fd && actidx < NUMACCTS) {
          actidx++;
        }
        if ( NUMACCTS == actidx) { 
          close_connection(NULL,&recvd_events_ptr[i]);
	  DP(1,("received event_poll on an unknown socket: %i", recvd_events_ptr[i].data.fd ) );
	}
        else { DP(10,("event_poll event received on %s",dataptr[actidx].account)); }

        if ( (recvd_events_ptr[i].events & EPOLLIN) == EPOLLIN ) {
           DP(10,("received epollin: 0x%x, ready to write on socket: %i\n",recvd_events_ptr[i].events, recvd_events_ptr[i].data.fd)); 
           read_data_from_socket(&dataptr[actidx], &recvd_events_ptr[i]);
           if ( 0 < dataptr[actidx].bytes_recvd ) {
              parse_data( &dataptr[actidx] );
              prev_time_data_recvd = time(NULL);
	
              market_open = TRUE;
              if ( TRUE == market_open && ( strategy_state_change(&dataptr[actidx]) ) ) {
		 dataptr[actidx].pending_orders = 1;
                 /* write_stops(positions); */
                 /* send_email("Placing order!!!", &positions[i]); send_email(i,"Placing order!!!"); */
              }
           }
        } /* if ( (recvd_events_ptr[i].events & EPOLLIN) == EPOLLIN ) */

        /* below epollout not required */
        if ( (recvd_events_ptr[i].events & EPOLLOUT) == EPOLLOUT ) { 
           DP(10,("received epollout: 0x%x, ready to write on socket: %i\n",recvd_events_ptr[i].events, recvd_events_ptr[i].data.fd)); 
           if (!dataptr[actidx].request_contract_details) dataptr[actidx].request_contract_details = request_contract_details(&dataptr[actidx]); 
	   else if (dataptr[actidx].request_contract_details && !dataptr[actidx].request_market_data) dataptr[actidx].request_market_data = request_market_data(&dataptr[actidx]); 
	   /* ASSUMING THAT NEXT_VALID_ID > 0 */
	   /* using the - below to ensure that place_order can return a 1 for successfull completion instead of a 0 on success */
	   else if (0 < dataptr[actidx].pending_orders && dataptr[actidx].request_contract_details && dataptr[actidx].request_market_data && dataptr[actidx].orderid) 
	     dataptr[actidx].pending_orders -= place_order(&dataptr[actidx]) ;
        } 
  
        if ( (recvd_events_ptr[i].events & EPOLLERR) == EPOLLERR ) {
           perror("socket error");
           DP(10,("received epollerr: 0x%x, ready to write on socket: %i\n",recvd_events_ptr[i].events, recvd_events_ptr[i].data.fd)); 
           close_connection(&dataptr[actidx],&recvd_events_ptr[i]);
        }
        if ( (recvd_events_ptr[i].events & EPOLLHUP) == EPOLLHUP ) {
           perror("socket hung");
           DP(10,("received epollhup: 0x%x, ready to write on socket: %i\n",recvd_events_ptr[i].events, recvd_events_ptr[i].data.fd)); 
           close_connection(&dataptr[actidx],&recvd_events_ptr[i]);
        }
        if ( 1 == dataptr[actidx].write_current_state ) {
	   email_state = 1;
           dataptr[actidx].write_current_state = 0;
	}
    } /* for (i = 0; i < sockets_with_events; i++) */
    if ( 1 == email_state ) {
       /* write state to a file */
       write_current_state(dataptr);
       /* email the new state */
       email_current_state();
       email_state = 0;
    }

  } /* while (1) */
  free(child_data_dir);
  /* Theoretically, I need to free the data assigned too */
  DE(10,"main");
  return 0;
}


