
#include "main.h"

int stgscan(Scanner *s){
	uchar *cursor = s->cur;
std:
	s->tok = cursor;
/*!re2c
any	= [\000-\377];
digit   = [0-9];
A       = [aA];
B       = [bB];
C       = [cC];
D       = [dD];
E       = [eE];
F       = [fF];
G       = [gG];
H       = [hH];
I       = [iI];
J       = [jJ];
K       = [kK];
L       = [lL];
M       = [mM];
N       = [nN];
O       = [oO];
P       = [pP];
Q       = [qQ];
R       = [rR];
S       = [sS];
T       = [tT];
U       = [uU];
V       = [vV];
W       = [wW];
X       = [xX];
Y       = [yY];
Z       = [zZ];
colon   = [ ]*[:]{1}[ ]*;
obrace   = [ ]*[{]{1}[ ]*;
cbrace   = [ ]*[}]{1}[ ]*;
indent   = [ ]*[-]{1}[ ]*;
*/

/*!re2c
	"/*"                    { goto comment; }
	U [0-9]+		{ RET(TOKACCOUNT); } 
/*	indent			{ RET(TOKINDENT); } */
	obrace			{ RET(TOKOBRACE); }
	cbrace			{ RET(TOKCBRACE); }
	[a-zA-Z]+			{ RET(TOKALPHA); }
	[=><!]+				{ RET(TOKOPERATORVALUE); }
	[-+]* digit + ("." digit * ("E" ([+-]) ? digit +) ?)* 	{ RET(TOKNUMBER); }
	P R I C E "_" T Y P E colon		{ RET(TOKPRICETYPE); }
	T R A D E "_" P R I C E colon		{ RET(TOKTRADEPRICE); }
	T R A D E "_" O P E R A T O R colon	{ RET(TOKTRADEOPERATOR); }
	T R A I L I N G "_" O P E R A T O R colon	{ RET(TOKTRAILOPERATOR); }
	T R A I L I N G "_" M A R G I N colon	{ RET(TOKTRAILMARGIN); }
	Q (U A N T I T Y)* colon		{ RET(TOKQUANTITY); }
 	S (T A T U S)* colon			{ RET(TOKSTATUS); } 
	T O colon				{ RET(TOKTRIGGEROPERATOR); }
	T R I G G E R "_" O P E R A T O R colon	{ RET(TOKTRIGGEROPERATOR); }
	T P colon				{ RET(TOKTRIGGERPRICE); }
	T R I G G E R "_" P R I C E colon	{ RET(TOKTRIGGERPRICE); }
	/* S Y M B O L colon	{ RET(TOKSYMBOL); } */
	S E C T Y P E colon	{ RET(TOKSECTYPE); } 
	/* E X P I R Y colon	{ RET(TOKEXPIRY); } */
	/* S T R I K E colon	{ RET(TOKSTRIKE); } */
	/* R I G H T colon	{ RET(TOKSTRIKE); } */
	colon					{ RET(TOKSTGLCOLON); }
	[ \t\v\f]+
	    {
	    /*	printf("received space\n"); */
		goto std;
	    }
	[\r\n]
	    {
		if(cursor == s->eof) RET(EOF);
		s->pos = cursor; s->line++;
		goto std;
	    }
	any
	    {
		printf("unexpected character: %c\n", *s->tok);
		goto std;
	    }
*/

comment: /*!re2c
	"*/"			{ goto std; }
	"\n"
	    {
		if(cursor == s->eof) RET(EOF);
		s->tok = s->pos = cursor; s->line++;
		goto comment;
	    }
        any			{ goto comment; }
*/
}

/*
main(){
    Scanner in;
    int t;
    memset((char*) &in, 0, sizeof(in));
    in.fd = 0;
    while((t = scan(&in)) != EOI){

	printf("%d\t%.*s\n", t, in.cur - in.tok, in.tok);
	printf("%d\n", t);

    }
    close(in.fd);
}
*/

uchar *fill(Scanner *s, uchar *cursor){
	if(!s->eof) {
		uint cnt = s->tok - s->bot;
		if(cnt){
			memcpy(s->bot, s->tok, s->lim - s->tok);
			s->tok = s->bot;
			s->ptr -= cnt;
			cursor -= cnt;
			s->pos -= cnt;
			s->lim -= cnt;
		}
		if((s->top - s->lim) < BSIZE){
			uchar *buf = (uchar*) malloc(((s->lim - s->bot) + BSIZE)*sizeof(uchar));
			memcpy(buf, s->tok, s->lim - s->tok);
			s->tok = buf;
			s->ptr = &buf[s->ptr - s->bot];
			cursor = &buf[cursor - s->bot];
			s->pos = &buf[s->pos - s->bot];
			s->lim = &buf[s->lim - s->bot];
			s->top = &s->lim[BSIZE];
			free(s->bot);
			s->bot = buf;
		}
		if((cnt = read(s->fd, (char*) s->lim, BSIZE)) != BSIZE){
			s->eof = &s->lim[cnt]; *(s->eof)++ = '\n';
		}
		s->lim += cnt;
	}
	return cursor;
}

