
%token_type {struct stgptokenvalue }  
/* %type	trades	{struct stgpnonterminal} */
%type	trade	{struct stgpnonterminal}
%type	stock	{struct stgpnonterminal}
%type	trades	{struct stgpnonterminal}
%type	tree_trades	{struct stgpnonterminal}
%type	strategy	{int}
%type	strategies	{int}
/*
%type	trades	{struct stgpterminal}
%type	trade	{struct stgpterminal}
%type	strategy	{struct stgpterminal}
*/
%extra_argument { struct data * dataptr}
%name stgparse
   
%include {   
#include "main.h"
}  
   
%syntax_error {  
printf("Syntax error!\n");
}   

program 	::= strategies.   { printf("Result: \n"); }
strategies(A)	::= strategies(B)	strategy(C).   { A=B+C; printf("Strategies: %i \n",A); }
strategies(A) 	::= strategy(B).   {A=B; printf("Strategies: %i \n",B); }
strategy(A) 	::= stock(B) trade(C).   {A=B.stkidx; printf("Strategies: %i \n",A); 
                     dataptr[B.actidx].stks[B.stkidx].current_trade_state = C.trdidx;
                     dataptr[B.actidx].stks[B.stkidx].roottrade = C.trdidx;
		     printf("at strategy = stock:%i trade:%i\n",B.stkidx, C.trdidx );
		     }
strategy(A) 	::= stock(B). { 
		     A = B.stkidx;printf("watch stock Strategies: %i \n",A); 
		     }
trades(A)	::= trades(B) trade(C).   {
		     A=B;
                     dataptr[A.actidx].trds[C.trdidx].parent = dataptr[A.actidx].trds[B.trdidx].parent ;
	             dataptr[A.actidx].trds[ dataptr[A.actidx].trds[C.trdidx].parent ].children[ dataptr[A.actidx].trds[ dataptr[A.actidx].trds[C.trdidx].parent ].no_of_children ] = C.trdidx;
	             dataptr[A.actidx].trds[ dataptr[A.actidx].trds[C.trdidx].parent ].no_of_children++; 
		     printf("at trades:%i = trades:%i trade:%i\n",A.trdidx,B.trdidx,C.trdidx);
		     }
trades(A)	::= trade(B).  {
		     A=B;
                     dataptr[A.actidx].trds[B.trdidx].parent = B.trdidx-1;
	             dataptr[A.actidx].trds[B.trdidx-1].children[(dataptr[A.actidx].trds[B.trdidx-1]).no_of_children] = B.trdidx;
	             dataptr[A.actidx].trds[B.trdidx-1].no_of_children++;
		     printf("at trades:%i = trade:%i\n",A.trdidx,B.trdidx);
		     }
trade(A)	::= trade(B) TOKOBRACE TOKCBRACE.    {
		     A = B;
		     printf("at trade:%i = trade:%i obrace blank cbrace\n",A.trdidx, B.trdidx );
		     }
trade(A)	::= trade(B) TOKOBRACE trades(C) TOKCBRACE.    {
		       A = B;
		     /* the below code is adding the children again. though safe, I do not feel the need for duplicate children */
                       /* dataptr[A.actidx].trds[C.trdidx].parent = B.trdidx; */
		       /* if ( 0 == dataptr[A.actidx].trds[B.trdidx].no_of_children || C.trdidx != dataptr[A.actidx].trds[B.trdidx].children[ dataptr[A.actidx].trds[B.trdidx].no_of_children ] ) { */
	                 /* dataptr[A.actidx].trds[B.trdidx].children[ dataptr[A.actidx].trds[B.trdidx].no_of_children ] = C.trdidx; */
	                 /* dataptr[A.actidx].trds[B.trdidx].no_of_children++; */
                       /* } */
		     
		     printf("at trade:%i = trade:%i obrace trades:%i cbrace\n",A.trdidx,B.trdidx,C.trdidx );
		     }
trade(A)  	::= TOKPRICETYPE TOKALPHA(B) TOKTRADEOPERATOR TOKOPERATORVALUE(C) TOKTRADEPRICE TOKNUMBER(D) TOKQUANTITY TOKNUMBER(E) TOKTRIGGEROPERATOR TOKOPERATORVALUE(F) TOKTRIGGERPRICE TOKNUMBER(G) TOKTRAILOPERATOR TOKOPERATORVALUE(H) TOKTRAILMARGIN TOKNUMBER(I) TOKSTATUS TOKNUMBER(J). {
		     A.trdidx = next_trd(&dataptr[C.actidx]);
		     A.actidx = C.actidx;

		     DP(1,("reducing status to: %i", atoi(J.value)) );
   		     dataptr[C.actidx].trds[A.trdidx].status = atoi((char *) J.value);
		     DP(1,("reducing trailing_operator to: %s", (char *) H.value) );
	             strcpy(dataptr[C.actidx].trds[A.trdidx].trailing_operator,(char *) H.value);
		     DP(1,("reducing trigger_operator to: %s", (char *)F.value ) );
	             strcpy(dataptr[C.actidx].trds[A.trdidx].trigger_operator,(char *) F.value);
		     DP(1,("reducing trigger_price to: %f", atof(G.value) ) );
   		     dataptr[C.actidx].trds[A.trdidx].trigger_price = atof(G.value);
		     DP(1,("reducing price_type to: %s",(char *) B.value ));
		     if ( 0 == strcasecmp(B.value, "BID") ||
		           0 == strcasecmp(B.value, "ASK") ||
		           0 == strcasecmp(B.value, "LAST") )
	                 strcpy(dataptr[B.actidx].trds[A.trdidx].price_type,(char *) B.value);
                     else {
		         DP(1,("unrecognized price_type: %s",(char *) B.value ));
		         exit(EXIT_FAILURE);
		      }
		     DP(1,("reducing trade_operator to: %s", (char *) C.value) );
	             strcpy(dataptr[C.actidx].trds[A.trdidx].trade_operator,(char *) C.value);
		     DP(1,("reducing trade_price to: %f", atof(D.value) ) );
   		     dataptr[C.actidx].trds[A.trdidx].trade_price = atof((char *) D.value);
		     DP(1,("reducing quantity to: %i", atoi(E.value) ) );
   		     dataptr[C.actidx].trds[A.trdidx].quantity = atoi((char *) E.value);
		     DP(1,("reducing trailing_margin to: %f", atof(I.value) ) );
   		     dataptr[C.actidx].trds[A.trdidx].trailing_margin = atof((char *) I.value);
	             dataptr[C.actidx].trds[A.trdidx].no_of_children = 0;
		     DP(1,("trade:%i = TOKENS", A.trdidx ) );
	             dataptr[C.actidx].trds[A.trdidx].index = A.trdidx;
		    }

stock(A)	::= TOKACCOUNT(B) TOKSTGLCOLON  TOKALPHA(C) TOKSECTYPE TOKALPHA(D).  { 
/* stock(A)	::= TOKACCOUNT(B) TOKSYMBOL TOKALPHA(C) TOKSECTYPE TOKALPHA(C) TOKEXPIRY TOKALPHA(C) TOKSTRIKE TOKNUMBER(C) TOKRIGHT TOKALPHA(C) TOKCURRENCY TOKALPHA(C).    */
		      A.stkidx = next_stk(&dataptr[B.actidx]) ;
		      if ( 0 != strcmp( B.value, "U11111" ) && 0 != strcmp( B.value,"U22222")) {
		         DP(1,("Unknown account: %s", (char *) B.value) );
			 exit(EXIT_FAILURE);
		      }
		      strcpy(dataptr[B.actidx].account,(char *) B.value) ;
	              printf("y:account:%s\n", (char *)B.value);
		      /* strcpy(dataptr[B.actidx].stks[A.stkidx].symbol,(char *) C.value) ; */
		      strcpy(dataptr[B.actidx].stks[A.stkidx].localsymbol,(char *) C.value) ;
	              printf("y:watch symbol:%s\n", (char *)C.value);
		      strcpy(dataptr[B.actidx].stks[A.stkidx].exchange,"SMART") ;
		      strcpy(dataptr[B.actidx].stks[A.stkidx].sectype,(char *) D.value) ;
	              printf("y:security type:%s\n", (char *)D.value);
		      dataptr[B.actidx].stks[A.stkidx].current_trade_state = -1;
		      dataptr[B.actidx].stks[A.stkidx].roottrade = -1;
		      A.actidx = B.actidx;
		     }


/*
strategy(A) 	::= stock(B). { A = B.stkidx;printf("watch stock Strategies: %i \n",A); }
strategy(A) 	::= stock(B) trade. { A=B.stkidx;printf("watch stock Strategies: %i \n",A); }
ts(A)		::= ts(B) trade(C).  {A=B;printf("at ts = ts:%i trade:%i\n",B,C.trdidx); }
ts(A)		::= trade(B).  {A=B.trdidx;printf("at ts = trade:%i\n",B.trdidx); }
ts(A)		::= ts(B) tc(C).   {A=B;printf("at ts = ts:%i tc:%i\n",B,C); }
ts(A)		::= tc(B).   {A=B;printf("at ts = tc:%i\n",B); }
tc(A)		::= trade(B) TOKOBRACE ts(C) TOKCBRACE.    {A = B.trdidx;printf("at tc = trade:%i obrace ts:%i cbrace\n",B.trdidx,C ); 
*/
/*
                      A = B;
                      dataptr[A.actidx].trds[D.trdidx].parent = B.trdidx;
	              dataptr[A.actidx].trds[B.trdidx].children[(dataptr[A.actidx].trds[B.trdidx]).no_of_children] = D.trdidx;
	              dataptr[A.actidx].trds[B.trdidx].no_of_children++;
		      */
